{$G+}

unit install1;
interface
uses instobjs;
var w1:twindow;
var disk:array[1..27] of record
                            z:char;
                            t:string;
                            i:word;
                          end;
    diskc:byte;

 function  Diskettes_Present : boolean;
 procedure extendCPU;
 function  IsCDRom:boolean;
 procedure nactidisky;
 function  RAMsize:longint;
 function  WinInstalled:boolean;
 function  GetCRC16(CRC:Integer;InBuf:string;InLen:Integer):Integer;
 procedure SafeFile(var f:text;s:string);

implementation
uses dos,drives,man_tool;

function Diskettes_Present : boolean;
begin
  Diskettes_Present := (MemW[$0000:0410] and $0001) <> 0;
end;

function IsCDRom:boolean;
Var
  Regs : Registers;
begin
   Regs.AX := $1500;
   Regs.BX := $0000;
   Regs.CX := $0000;
   Intr( $2F, Regs);
   IsCDRom:=(Regs.BX > 0);
end;

procedure extendCPU;
begin
  if (Test8086 = 2) then         { RTL check stops at 2 = 386}
  asm
             inc    Test8086     { 3 = 386, for consistency }
    { Do we have a 386 or a 486? }
    { Does pushf/popf preserve the Alignment Check bit? (386=no, 486=yes) }
             mov    bx, sp       { save current stack pointer }
             and    sp, not 3    { align stack to avoid AC fault }
    db $66;  pushf
    db $66;  pop    ax
    db $66;  mov    cx, ax
    db $66, $35; dd $40000       { xor AC bit in EFLAGS }
    db $66;  push   ax
    db $66;  popf
    db $66;  pushf
    db $66;  pop    ax
    db $66;  xor    ax, cx       { Is AC bit toggled? }
             je @@1              { if not, we have a 386 }
             and    sp, not 3    { align stack to avoid AC fault }
    db $66;  push   cx
    db $66;  popf                { restore original AC bit }
             mov    sp, bx       { restore original stack pointer }
             mov  Test8086, 4    { we know we have at least a 486 }

    { Do we have a 486 or a Pentium? }
    { Does pushf/popf preserve the CPUID bit? (486=no, P5=yes) }
    db $66;  mov    ax, cx       { get original EFLAGS}
    db $66, $35; dd $200000      { XOR id bit in flags}
    db $66;  push   ax
    db $66;  popf
    db $66;  pushf
    db $66;  pop    ax
    db $66;  xor    ax, cx      { Is CPUID bit toggled? }
             je @@1             { if not, we have a 486 }
    db $66;  xor    ax, ax
    db $f,$a2                   { CPUID, AX = 0 (get CPUID caps) }
    db $66;  cmp    ax, 1
             jl @@1             { if < 1, then exit }
    db $66;  xor    ax, ax
    db $66;  inc    ax
    db $f,$a2                   { CPUID, AX = 1 (get CPU info)   }
             and    ax, $f00    { mask out all but family id }
             shr    ax, 8
             mov    Test8086, al      { Pentium family = 5 }
   @@1:
  end;
end;

procedure nactidisky;
var
  AllDrives: DriveSet;
  D        : DriveLetters;
  DriveType: LongInt;
  S        : String;
  i        : Integer;
begin
  GetDrives (AllDrives);
  for D := 'A' to 'Z' do
  begin
    if NOT (D in AllDrives) then Continue;
{    i:=pFloppy35;}
    DriveType := GetDriveType (D);
    if DriveType = dtInvalid then Continue;
    if DriveType and dtUnknown = dtUnknown then
    begin
      S := ' neznm jednotka';
      if DriveType and dtRemote = dtRemote then
        S := 'vzdlen' + S;
{      i:=pFloppy35;}
    end
    else if DriveType and dtAnyFloppy <> 0 then
    begin
      S := ' disketov jednotka';
      case DriveType and dtAnyFloppy of
        dt8Single: S := '8" SD' + S;
        dt8Double: S := '8" DD' + S;
        dt360    : S := '320/360 KB' + S;
        dt720    : S := '720 KB' + S;
        dt1200   : S := '1.2 MB' + S;
        dt1440   : S := '1.44 MB' + S;
        dt2880   : S := '2.88 MB' + S
      end;
{      i:=pFloppy35;}
    end
    else if DriveType and dtTape = dtTape then
    begin
      S := ' pksov jednotka';
      if DriveType and dtRemote = dtRemote then
        S := 'vzdlen' + S;
{      i:=pFloppy35;}                                     {*}
    end
    else if DriveType and dtFloptical = dtFloptical then
    begin
      S := 'disketov jednotka';
      if DriveType and dtRemote = dtRemote then
        S := 'vzdlen ' + S;
{      i:=pFloppy35;}
    end
    else if DriveType and dtCDRom = dtCDRom then
    begin
      S := ' CD-ROM';
      if DriveType and dtRemote = dtRemote then
        S := 'vzdlen' + S;
{      i:=pCD;}
    end
    else if DriveType and dtIomegaZip = dtIomegaZip then
    begin
      S := ' Iomega Zip';
      if DriveType and dtRemote = dtRemote then
        S := 'vzdlen' + S;
{      i:=pFloppy35;}
    end
    else begin
      if DriveType and dtRemovable = dtRemovable then
      begin
        S := ' vymniteln medium';
        if DriveType and dtRemote = dtRemote then
          S := 'vzdlen' + S
      end
      else begin
        s:='';
        if DriveType and dtRemote = dtRemote then
          S := S + 'vzdlen ';
        if DriveType and dtRamDisk = dtRamDisk then
        begin
{          i:=pRAMdisk;}
          S := S + ' RAM';
        end
        else begin S := S + ' Hard';
{        i:=pHD;}
        end;
        S := S + ' Disk'
      end
    end;
    diskc:=diskc+1;
    disk[diskc].t:=s;
    disk[diskc].z:=d;
    disk[diskc].i:=i;
  end
end;

const CMOSport=$70;
function readCMOS(adr: byte): byte;
var
      i: byte;
begin
  inline($FA);
  Port[CMOSport]:=adr;
  for i:=1 to 10 do;
  readCMOS:=Port[CMOSport + 1];
  inline($FB)
end; {readCMOS}

function  RAMsize:longint;
var rsize:longint;
begin
 rsize:=      (word(256) * readCMOS($16)) + readCMOS($15);
 rsize:=rsize+(word(256) * readCMOS($18)) + readCMOS($17);
 ramsize:=rsize;
end;
function  WinInstalled:boolean;
var wi:boolean;i:integer;s:string;
begin
 wi:=false;
 for i:=1 to envcount do
     begin
      s:=uppercase(EnvStr(I));
      if pos('WINBOOTDIR',s)=1 then wi:=true;
     end;
 WinInstalled:=wi;
end;
function     GetCRC16(CRC       : Integer;      { CRC-16 to update  }
                      InBuf     : string;       { Pointer to data   }
                      InLen     : Integer) :Integer;  { data count  }
    Var Bit, ByteCount          : Integer;
        Carry                   : Boolean;      { catch overflow    }
    begin
    For ByteCount := 1 to InLen do              { all data Bytes    }
        For Bit := 7 downto 0 do begin          { 8 bits per Byte   }
            Carry := CRC and $8000 <> 0;        { shift overlow?    }
            CRC := CRC SHL 1 or ord(InBuf[ByteCount]) SHR Bit and 1;
            if Carry then CRC := CRC xor $1021; { apply polynomial  }
        end; { For Bit & ByteCount }            { all Bytes & bits  }
    GetCRC16 := CRC;                            { updated CRC-16    }
    end;

procedure SafeFile(var f:text;s:string);
var D: DirStr; N: NameStr; E: ExtStr;
var t,f1:file;s1:string;
begin
 s:=fexpand(s);
 fsplit(s,d,n,e);
 e:='.old';
 s1:=n+e;

 assign(t,s);
 {$I-}rename(t,s1);{$I+}
 if IOResult<>0 then
    begin {$I-}assign(f1,s1);erase(f1);rename(t,s1);{$I+}end;


 assign(f,s1);
 reset(f);
end;
end.




