unit vga;
{$G+}
interface
 const       m320x200  =$13;          {320  x 200  256}
             m640x480  =$12;          {640  x 480  16}
             m800x600  = $103;        {800  x 600  256}
             m1024x768 = $105;        {1024 x 768  256}

 type tscreen=array [1..320*200] of byte;
      FontChar=ARRAY[0..5] OF BYTE;
      Font=ARRAY[0..255] OF Fontchar;
      CharType=array[0..15] of byte;
      FontType=array[0..255] of chartype;
      PCXInfoType=record
                   ver,comp:byte;
                   x,y:word;
                   palette:array[0..255,1..3] of byte;
                  end;


  clearscrproc=  procedure;
  fillscreenproc=procedure (b:byte);
  putpixelproc=  procedure (x,y:integer;c:byte);
  getpixelproc=  function  (x,y:integer):byte;
  notpixelproc=  procedure (x,y:integer);
  rectangleproc= procedure (x,y,x1,y1:integer;b:byte);
  frameproc=     procedure (x,y,x1,y1:integer;b,b1,b2,b3:byte);
  barproc=       procedure (x,y,x1,y1:integer;b:byte);
  vlineproc=     procedure (x,y,l:integer;b:byte);
  hlineproc=     procedure (x,y,l:integer;b:byte);
  circleproc=    procedure (x,y,r:integer;b:byte);
  lineproc=      procedure (x,y,x2,y2:integer;b:Byte);
  putpictureproc=procedure (vx,vy:word;p:pointer);
 var
  clearscr:clearscrproc;
  fillscreen:fillscreenproc;
  putpixel:putpixelproc;
  getpixel:getpixelproc;
  notpixel:notpixelproc;
  rectangle:rectangleproc;
  frame:frameproc;
  bar:barproc;
  vline:vlineproc;
  hline:hlineproc;
  circle:circleproc;
  line:lineproc;
  putpicture:putpictureproc;
  ignorecolor:byte;
 type RGBPalette = Array[0..255,1..3] of Byte;
      RGBpalette16=array[1..16,1..3] of byte;
 var pscreen16h:pointer;
     screen: ^tscreen; {absolute ^pscreen16h; $A000:0000}
     mode:word;
     TextOrientation:(Vertical,Horizontal);


 var maxx,
     maxy,
     colors,
     aktualmode:word;
     mouseinstalled:boolean;
     mousebuttons:byte;
 var ingraph:boolean;

{Mod 320x200 256 barev    -- 13h}

 function  IsVGA:boolean;
 procedure initgraph(mode:word);
 procedure closegraph;
 procedure clearscr13h;
 procedure fillscreen13h(b:byte);
 procedure putpixel13h(x,y:integer;c:byte);
 function  getpixel13h(x,y:integer):byte;
 procedure notpixel13h(x,y:integer);
 procedure rectangle13h(x,y,x1,y1:integer;b:byte);
 procedure frame13h(x,y,x1,y1:integer;b,b1,b2,b3:byte);
 procedure bar13h(x,y,x1,y1:integer;b:byte);
 procedure vline13h(x,y,l:integer;b:byte);
 procedure hline13h(x,y,l:integer;b:byte);
 procedure circle13h(x,y,r:integer;b:byte);
 procedure line13h(x,y,x2,y2:integer;b:Byte);
 procedure OutText6x6(x,y:word;s:string;c:byte);
 procedure OutText(x,y:word;s:string;c:byte;p:pointer);
 function  loadpicture(s:string):pointer;
 function  loadpicturef(var f:file):pointer;
 function  getpicture(x,y,x1,y1:integer):pointer;
 procedure getpicturep(x,y,x1,y1:integer;p:pointer);
 procedure deletepicture(p:pointer);
 procedure putpicture13h(vx,vy:word;p:pointer);

{Mod 640x480 16 barev    -- 12h}
 procedure clearscr12h;
 procedure putpixel12h(x,y:integer;c:byte);
 function  getpixel12h(x,y:word):byte;
 procedure hline12h(x,y,length:integer;color:byte);
 procedure vline12h(x,y,length:integer;color:byte);
 procedure rectangle12h(x,y,x1,y1:word;Color:byte);
 procedure frame12h(x,y,x1,y1:integer;b,b1,b2,b3:byte);
 procedure bar12h(x,y,Width,Height:word;Color:byte);
 procedure putpicture12h(vx,vy:word;p:pointer);

{VESA mod}
 procedure putpixelVESA(x, y : integer; c : byte);
{ procedure hLineVESA(x,x2,y:integer;c:byte);
 procedure putpictureVESA(x, y : integer; p : pointer);}

{Standartni procedury a funkce}
 procedure initstd;
 procedure clearscrSTD;
 procedure fillscreenSTD(b:byte);
 procedure notpixelSTD(x,y:integer);
 procedure barSTD(x,y,x1,y1:integer;b:byte);
 procedure rectangleSTD(x,y,x1,y1:integer;b:byte);
 procedure frameSTD(x,y,x1,y1:integer;b,b1,b2,b3:byte);
 procedure vlineSTD(x,y,l:integer;b:byte);
 procedure hlineSTD(x,y,l:integer;b:byte);
 procedure circleSTD(x,y,r:integer;b:byte);
 procedure lineSTD(x,y,x2,y2:integer;b:Byte);
 procedure putpictureSTD(vx,vy:word;p:pointer);


{Obecne procedury a funkce pro praci s grafikou}
 function  getbestcolor(r,g,b:byte):byte;
 function  getbestcolorr(r,g,b:byte;min,max:byte):byte;
 procedure twocolorhbar(x,y,x1,y1:integer;b,b1:byte);
 procedure GetPalette(index2get : Byte; VAR r_inte, g_inte, b_inte : Byte);
 procedure SetPalette(index2set, r_inte, g_inte, b_inte : Byte);
 procedure newpal;
 procedure BurstSetPalette(burstPalette : RGBPalette);
 procedure BurstSetPalette16(burstPalette : RGBPalette16);
 procedure WaitRetrace;

{Mys}
 procedure initmouse;
 procedure showmouse;
 procedure hidemouse;
 procedure setmouse(x,y:word);
 procedure mousestatus(var x,y:word;var tl1,tl2,tl3:boolean);
 procedure mousepoz(var x,y:word);
 procedure mouseminmax(minx,miny,maxx,maxy:word);
 procedure mkurzor(p:pointer;x,y:integer);
 procedure setmcurzor(ktery:byte);

{Uzitecne veci}
 function  inttostr(i:integer):string;
 function  longinttostr(i:longint):string;
 function  inarea(wx,wy,x1,y1,x2,y2:integer):boolean;
 function  charx(ch:char;poc:integer):string;
 procedure nic;


{PCX obrazky}
 procedure PCXfileinfo(s:string;var inf:PCXinfotype);
 procedure loadPCXfile(xx,yy:word;s:string);

{Odkazy na fonty. NIKDY NEVOLAT!!!}
procedure space;
procedure scify;
procedure normal;
procedure fun;
procedure scri;

const winpal:RGBPalette16=((0,0,0),(32,0,0),(0,32,0),(32,32,0),(0,0,32),(32,0,32),
                         (0,32,32),(32,32,32),(48,48,48),(63,0,0),(0,63,0),(63,63,0),
                         (0,0,63),(63,0,63),(0,63,63),(63,63,63));
implementation
uses crt,dos;
var OrigMode:integer;
type  g_kurzor = array [ 0 .. 1, 0 .. 15 ] of word;
{$I vgainc.pas}
{$I vga_std.pas}
{$I vgainc12.pas}
{$I vga_vesa.pas}
{$F+}
procedure space;external;
{$L SPACE}
procedure scify;external;
{$L SCIFY}
procedure normal;external;
{$L NORMAL}
procedure fun;external;
{$L FUN}
procedure scri;external;
{$L SCRI}
procedure font8x8;external;
{$L 8x8}
function IsVGA:boolean;
var Regs:registers;
begin
 with Regs do
  begin
   AX:=$1A00;
   Intr($10,Regs);
   IsVGA:=(AL=$1A) AND
          ((BL=7) OR (BL=8))
  end;
end;

{*********************** Vlastni myska ***********************}
var  oldvec08:procedure;ready,showm:boolean;
     lastm,writemode:(normalmode,andmode,ormode,xormode);
     mousx,mousy,smx,smy:word;mco,mstart:boolean;
     curzm:g_kurzor;savm:array[0..15,0..15] of byte;
     mct256:boolean;curzm256:array [ 0 .. 15, 0 .. 15 ] of byte;
{$F+}
function getbite(cislo,bit:byte):byte;
var x:array[1..8] of byte;l,i:byte;
begin
 l:=cislo;for i:=8 downto 1 do
 begin
  x[i]:=l mod 2;
  l:=l div 2;
 end;getbite:=x[bit];
end;
procedure INT08; interrupt;
var i,l:byte;
begin
 inline($9C);
 oldvec08;
 if (ready=true) and (showm=true) then
 begin
  ready:=false;
  lastm:=writemode;
  writemode:=normalmode;
  mousepoz(mousx,mousy);
  if (smx<>mousx) or (smy<>mousy) or (mco=true) then
  begin
  if mousy>maxy-9 then begin setmouse(mousx,maxy-9);mousepoz(mousx,mousy);end;
  if mousx>maxx-8 then begin setmouse(maxx-8,mousy);mousepoz(mousx,mousy);end;
  if showm=true then
  begin
   mco:=false;
   if mstart=false then for i:=0 to 15 do for l:=0 to 15 do putpixel(smx+i,smy+l,savm[i,l])
                   else mstart:=false;
   for i:=0 to 15 do for l:=0 to 15 do savm[i,l]:=getpixel(mousx+i,mousy+l);
   if mct256=true then
   begin
    for i:=0 to 15 do for l:=0 to 15 do if curzm256[i,l]<>0 then putpixel(mousx+i,mousy+l,curzm256[i,l]);
   end else
   begin
    for i:=0 to 15 do
    begin
    for l:=1 to 8 do
    begin
     if (getbite(lo(curzm[0,i]),l)=0) and (getbite(lo(curzm[1,i]),l)=0) then putpixel(mousx+l+7,mousy+i,0);
     if (getbite(lo(curzm[0,i]),l)=0) and (getbite(lo(curzm[1,i]),l)=1) then putpixel(mousx+l+7,mousy+i,15);
     if (getbite(lo(curzm[0,i]),l)=1) and (getbite(lo(curzm[1,i]),l)=1) then
     begin
      writemode:=xormode;
      putpixel(mousx+l+7,mousy+i,255);
      writemode:=normalmode;
     end;
   end;
   for l:=1 to 8 do
   begin
    if (getbite(hi(curzm[0,i]),l)=0) and (getbite(hi(curzm[1,i]),l)=0) then putpixel(mousx+l-1,mousy+i,0);
    if (getbite(hi(curzm[0,i]),l)=0) and (getbite(hi(curzm[1,i]),l)=1) then putpixel(mousx+l-1,mousy+i,15);
    if (getbite(hi(curzm[0,i]),l)=1) and (getbite(hi(curzm[1,i]),l)=1) then
    begin
     writemode:=xormode;
     putpixel(mousx+l-1,mousy+i,255);
     writemode:=normalmode;
    end;
   end;
  end;
  end;
  end;
 end;
  smx:=mousx;smy:=mousy;
  writemode:=lastm;
  ready:=true;
end;
end;
{$F-}
{*********************** Vlastni myska ***********************}

procedure initgraph(mode:word);
begin
 ingraph:=true;
 OrigMode := LastMode;
 initstd;
 aktualmode:=mode;
 case mode of
 m320x200:
         begin
          asm
            mov ax, 0013h
            int 10h
          end;
          @clearscr:=@clearscr13h;
          @fillscreen:=@fillscreen13h;
          @putpixel:=@putpixel13h;
          @getpixel:=@getpixel13h;
          @notpixel:=@notpixel13h;
          @rectangle:=@rectangle13h;
          @frame:=@frame13h;
          @bar:=@bar13h;
          @vline:=@vline13h;
          @hline:=@hline13h;
          @circle:=@circle13h;
          @line:=@line13h;
          @putpicture:=@putpicture13h;
          maxx:=319;maxy:=199;colors:=256;
         end;
 m640x480:
         begin
           Asm
            Mov     ax,12h
            Int     10h
           end;
          @clearscr:=@clearscr12h;
          @putpixel:=@putpixel12h;
          @getpixel:=@getpixel12h;
          @rectangle:=@rectangle12h;
          @frame:=@frame12h;
{          @bar:=@bar12h;}
          @vline:=@vline12h;
          @hline:=@hline12h;
          @putpicture:=@putpicture12h;
          maxx:=639;maxy:=479;colors:=16;
         end;
  else if mode>$13 then setVESAmode(mode);
 end;
 getintvec($08,@OldVec08);
 setintvec($08,@INT08);
end;

procedure closegraph;
begin
 ingraph:=false;
 setintvec($08,@OldVec08);
 delay(55);
 TextMode(OrigMode);
end;

procedure clearscr13h;
begin
 fillchar(screen^,320*200,0)
end;

procedure fillscreen13h(b:byte);
begin
 fillchar(screen^,320*200,b)
end;

procedure putpixel13h(x,y:integer;c:byte);
begin
 screen^[x+y*320]:=c
end;

function getpixel13h(x,y:integer):byte;
begin
 getpixel13h:=screen^[x+y*320];
end;

procedure notpixel13h(x,y:integer);
begin
 screen^[x+y*320]:=not screen^[x+y*320];
end;

procedure bar13h(x,y,x1,y1:integer;b:byte);
var i:integer;
begin
 for i:=y to y1 do
 begin
  fillchar(screen^[x+i*320],x1-x+1,b);
 end;
end;

procedure twocolorhbar(x,y,x1,y1:integer;b,b1:byte);
var i:integer;
begin
 for i:=y to y1 do
 begin
  if i mod 2=0 then
   hline(x,i,x1-x,b)
  else
   hline(x,i,x1-x,b1);
 end;
end;
procedure rectangle13h(x,y,x1,y1:integer;b:byte);
var i:integer;
begin
 fillchar(screen^[x+y*320],x1-x+1,b);
 for i:=y+1 to y1-1 do
 begin
  screen^[x+i*320]:=b;
  screen^[x1+i*320]:=b;
 end;
 fillchar(screen^[x+y1*320],x1-x+1,b);
end;

procedure frame13h(x,y,x1,y1:integer;b,b1,b2,b3:byte);
var i:integer;
begin
 fillchar(screen^[x+y*320],x1-x+1,b);
 for i:=y+1 to y1-1 do
 begin
  screen^[x+i*320]:=b3;
  screen^[x1+i*320]:=b1;
 end;
 fillchar(screen^[x+y1*320],x1-x+1,b2);
end;

procedure vline13h(x,y,l:integer;b:byte);
var i:integer;
begin
 for i:=y to y+l-1 do screen^[x+i*320]:=b;
end;

procedure hline13h(x,y,l:integer;b:byte);
begin
 fillchar(screen^[x+y*320],l+1,b);
end;

procedure circle13h(x,y,r:integer;b:byte);
var x1,y1:integer;
    a : real;
begin
 a:=0;
 repeat
  y1:=round(-1*(r*sin(a)))+y;
  x1:=round(r*cos(a))+x;
  screen^[x1+y1*320]:=b;
  a:=a+0.25;
 until a=360.25;
end;

procedure line13h(x,y,x2,y2:integer;b:Byte);
var
 d,dx,dy,ai,bi,xi,yi : integer;
begin
 if x < x2 then begin xi := 1; dx := x2-x; end
 else begin xi := -1; dx := x-x2; end;
 if y < y2 then begin yi := 1; dy := y2-y; end
 else begin yi := -1; dy := y-y2; end;
 if (x>=0)and(x<=639)and(y>=0)and(y<=479)then screen^[x+y*320]:=b;
 if dx > dy then begin
  ai := (dy-dx)*2; bi := dy*2; d := bi-dx;
  repeat
   if d >= 0 then begin inc(y,yi); inc(d,ai); end else inc(d,bi);
   inc(x,xi); if (x>=0)and(x<=639)and(y>=0)and(y<=479)then screen^[x+y*320]:=b;
  until x = x2;
 end
 else begin
  ai := (dx-dy)*2; bi := dx*2; d := bi-dy;
  repeat
   if d >= 0 then begin inc(x,xi); inc(d,ai); end else inc(d,bi);
   inc(y,yi); if (x>=0)and(x<=639)and(y>=0)and(y<=479)then screen^[x+y*320]:=b;
  until y = y2;
 end;
end;

procedure OutText(x,y:word;s:string;c:byte;p:pointer);
const FontMask:array[0..7] of byte=($80,$40,$20,$10,8,4,2,1);
var z,bit,i:byte;ii,ll:integer;
    data:CharType;
begin
 for i:=1 to Length(s) do
 begin
  move(ptr(seg(p^),ofs(p^)+ord(s[i])*16)^,data[0],16);
  for z:=0 to 15 do
  begin
   for bit:=0 to 7 do
       if data[z] and FontMask[bit]<>0 then PutPixel(x+bit,y+z,c);
  end;
  inc(x,8)
 end;
end;
{procedure OutText(x,y:word;s:string;c:byte;p:pointer);
var z,b,bit,i:byte;Fh,Fw:byte;ii,ll:integer;
    data:CharType;zn:fonttype;
begin
 for ii:=0 to 255 do for ll:=1 to 16 do zn[ii,ll]:=mem[seg(p^):ofs(p^)+(ii*16)+ll];
 fh:=16;fw:=8;
 for i:=1 to Length(s) do
 begin
  data:=zn[ord(s[i])];
  for z:=0 to fh-1 do
   begin
    b:=data[z];
    for bit:=0 to fw-1 do
     if b and FontMask[bit]<>0
      then PutPixel(x+bit,y+z,c);
   end;
  if TextOrientation=horizontal
   then inc(x,fw)
   else inc(y,fh);
 end;
end;}

procedure OutText6x6(x,y:word;s:string;c:byte);
var z,b,bit,i:byte;Fh,Fw:byte;
    data:FontChar;
begin
 fh:=6;fw:=6;
 for i:=1 to Length(s) do
 begin
  data:=FontData[ord(s[i])];
  for z:=0 to fh-1 do
   begin
    b:=data[z];
    for bit:=0 to fw-1 do
     if b and FontMask[bit]<>0
      then putpixel(x+bit,y+z,c);
   end;
  if TextOrientation=horizontal
   then inc(x,fw)
   else inc(y,fh);
 end;
end;

PROCEDURE GetPalette(index2get : Byte; VAR r_inte, g_inte, b_inte : Byte);
{ returns the r, g, and b values of a palette index }
BEGIN
  Port[$3C7] := index2get;
  r_inte := Port[$3C9];
  g_inte := Port[$3C9];
  b_inte := Port[$3C9];
END;

PROCEDURE SetPalette(index2set, r_inte, g_inte, b_inte : Byte);
{ sets the r, g, and b values of a palette index }
BEGIN
  Port[$3C8] := index2set;
  Port[$3C9] := r_inte;
  Port[$3C9] := g_inte;
  Port[$3C9] := b_inte;
END;

PROCEDURE BurstSetPalette(burstPalette : RGBPalette);
VAR
  burstCount,burstCount1 : Word;
BEGIN
  Port[$3C8] := 0;
  FOR burstCount := 0 TO 255 DO
  FOR burstCount1 := 1 TO 3 DO
  Port[$3C9] := burstPalette[burstCount,burstCount1];
END;
PROCEDURE BurstSetPalette16(burstPalette : RGBPalette16);
VAR
  burstCount,burstCount1 : Word;
BEGIN
  Port[$3C8] := 0;
  FOR burstCount := 1 TO 16 DO
  FOR burstCount1 := 1 TO 3 DO
  Port[$3C9] := burstPalette[burstCount,burstCount1];
END;
procedure newpal;
begin
 BurstSetPalette(newpalette);
end;
procedure putpicture13h(vx,vy:word;p:pointer);
var i,l,x,y:integer;se:word;off:word;
begin
 se:=seg(p^);off:=ofs(p^);
 x:=memw[se:off];
 y:=memw[se:off+2];
 for l:=0 to y-1 do
 for i:=0 to x-1 do
 begin
  if mem[se:off+4+(l*x)+i]<>0 then
  screen^[(i+vx)+(l+vy)*320]:=mem[se:off+(l*x)+4+i];
 end;
end;

function getpicture(x,y,x1,y1:integer):pointer;
var i,l:integer;se,off:word;p:pointer;
begin
 getmem(p,(x1-x)*(y1-y)+4);
 getpicture:=p;
 se:=seg(p^);off:=ofs(p^);
 memw[se:off]:=x1-x;
 memw[se:off+2]:=y1-y;
 for l:=0 to y1-y-1 do
 for i:=0 to x1-x-1 do
 begin
  mem[se:off+(l*(x1-x))+4+i]:=getpixel(x+i,y+l);
 end;
end;

procedure getpicturep(x,y,x1,y1:integer;p:pointer);
var i,l:integer;se,off:word;
begin
 se:=seg(p^);off:=ofs(p^);
 memw[se:off]:=x1-x;
 memw[se:off+2]:=y1-y;
 for l:=0 to y1-y-1 do
 for i:=0 to x1-x-1 do
 begin
  mem[se:off+(l*(x1-x))+4+i]:=getpixel(x+i,y+l);
 end;
end;

function  loadpicture(s:string):pointer;
var f:file;
    len:longint;
    p1:pointer;x,y:word;
begin
 assign(f,s);
 {$I-} reset(f,1);{$I+}
 if ioresult<>0 then
 begin
  closegraph;
  writeln('Nelze otevrit soubor "'+s+'".');
  halt;
 end;
 len:=x*y+4;
 seek(f,filepos(f)-4);
 if (maxavail<len) then
 begin
  closegraph;
  writeln('Nelze nacist soubor "'+s+'". Jeho velikost je ',len div 1024,'Kb, ale je dostupne jen ',
           memavail div 1024,'Kb pameti.');
  halt;
 end;
 getmem(p1,filesize(f));
 {$I-}
  blockread(f,p1^,filesize(f));
 {$I+}
 if ioresult<>0 then
 begin
  closegraph;
  writeln('Chyba pri cteni souboru "'+s+'".');
  halt;
 end;
 loadpicture:=p1;
 close(f);
end;

function  loadpicturef(var f:file):pointer;
var len:longint;
    p1:pointer;
    x,y:word;
begin
 blockread(f,x,sizeof(x));
 blockread(f,y,sizeof(y));
 len:=x*y+4;
 seek(f,filepos(f)-4);
 if (maxavail<len) then
 begin
  closegraph;
  writeln('Nelze nacist obrazek. Jeho velikost je ',len div 1024,'Kb, ale je dostupne jen ',
           memavail div 1024,'Kb pameti.');
  halt;
 end;
 getmem(p1,len);
 {$I-}
  blockread(f,p1^,len);
 {$I+}
 if ioresult<>0 then
 begin
  closegraph;
  writeln('Chyba pri cteni souboru s obrazkem.');
  halt;
 end;
 loadpicturef:=p1;
end;

procedure deletepicture(p:pointer);
var x,y:word;
begin
 x:=memw[seg(p^):ofs(p^)];
 y:=memw[seg(p^):ofs(p^)+2];
 freemem(p,x*y+4);
end;

procedure volani_mysky ( sluzba : byte; var par1, par2, par3, par4 : word );
var  r : registers;
begin
 r.ax:=sluzba; r.bx:=par2;
 r.cx:=par3; r.dx:=par4;
 intr(51,r);
 par1:=r.ax; par2:=r.bx;
 par3:=r.cx; par4:=r.dx;
end;

procedure showmouse;{assembler;
asm
 mov ax, 1
 int 33h
end;}
var i,l:integer;
begin
  for i:=0 to 15 do for l:=0 to 15 do savm[i,l]:=getpixel(mousx+i,mousy+l);
  mco:=true;
  showm:=true;
end;


procedure hidemouse;{assembler;
asm
 mov ax, 2
 int 33h
end;}
var i,l:integer;
begin
  showm:=false;
   if mstart=false then for i:=0 to 15 do for l:=0 to 15 do putpixel(smx+i,smy+l,savm[i,l])
                   else mstart:=false;
end;

procedure initmouse;
var r:registers;d,d1,d2:word;
begin
 volani_mysky(0,d,d1,d2,d2);
 mouseinstalled:=d=$FFFF;
 mousebuttons:=d1;
end;

procedure setmouse(x,y:word);
var r:registers;d:word;
begin
 volani_mysky(4,d,d,x,y);
end;

procedure mousestatus(var x,y:word;var tl1,tl2,tl3:boolean);
var d,tl:word;r:registers;
begin
 volani_mysky(3,d,tl,x,y);
 tl1:=odd(tl); tl2:=odd(tl shr 1); tl3:=odd(tl shr 2);
end;

procedure mousepoz(var x,y:word);
var d,tl:word;r:registers;
begin
 volani_mysky(3,d,tl,x,y);
end;

procedure mouseminmax(minx,miny,maxx,maxy:word);
var r:registers;d:word;
begin
 volani_mysky(7,d,minx,maxx,d);
 volani_mysky(8,d,miny,maxy,d);
end;

procedure mkurzor(p:pointer;x,y:integer);
var r:registers;d,i,l:word;
begin
 r.ax:=9;
 r.es:=seg(p^);
 r.dx:=ofs(p^);
 r.bx:=x;r.cx:=y;
 intr($33,r);

 mct256:=false;
 for i:=0 to 1 do for l:=0 to 15 do curzm[i,l]:=memw[seg(p^):ofs(p^)+((i*16)+l)*2];
 mco:=true;
end;
procedure setmcurzor(ktery:byte);
begin
 case ktery of
      1:mkurzor(@k_sipka,x_sipka,y_sipka);
      2:mkurzor(@k_kriz,x_kriz,y_kriz);
      3:mkurzor(@k_xkriz,x_xkriz,y_xkriz);
      4:mkurzor(@k_hodinky,x_hodinky,y_hodinky);
      5:mkurzor(@k_hodinky,x_hodinky,y_hodinky);
      6:mkurzor(@k_presipacky,x_presipacky,y_presipacky);
      7:mkurzor(@k_otaznik,x_otaznik,y_otaznik);
      8:mkurzor(@k_ruka,x_ruka,y_ruka);
      9:mkurzor(@k_ok,x_ok,y_ok);
     10:mkurzor(@k_no,x_no,y_no);
     11:mkurzor(@k_sipkaSZxJV,x_sipkaSZxJV,y_sipkaSZxJV);
     12:mkurzor(@k_sipkaSxJ,x_sipkaSxJ,y_sipkaSxJ);
     13:mkurzor(@k_sipkaSVxJZ,x_sipkaSVxJZ,y_sipkaSVxJZ);
     14:mkurzor(@k_sipkaVxZ,x_sipkaVxZ,y_sipkaVxZ);
     15:mkurzor(@k_sipkaZ,x_sipkaZ,y_sipkaZ);
     16:mkurzor(@k_sipkaS,x_sipkaS,y_sipkaS);
     17:mkurzor(@k_sipkaV,x_sipkaV,y_sipkaV);
     18:mkurzor(@k_sipkaJ,x_sipkaJ,y_sipkaJ);
     19:mkurzor(@k_textkurzor,x_textkurzor,y_textkurzor);
     20:mkurzor(@k_zamerovac,x_zamerovac,y_zamerovac);
 end;
end;

Procedure WaitRetrace; Assembler;
       Asm
         mov     dx,3dah
 @L1:
         in      al,dx
         test    al,08h
         jne     @L1
 @L2:
         in      al,dx
         test    al,08h
         je      @L2
End;

function inttostr(i:integer):string;
var s:string;
begin
 str(i,s);
 inttostr:=s;
end;
function longinttostr(i:longint):string;
var s:string;
begin
 str(i,s);
 longinttostr:=s;
end;


function  inarea(wx,wy,x1,y1,x2,y2:integer):boolean;
begin
 inarea:=true;
 if wx<x1 then inarea:=false;
 if wx>x2 then inarea:=false;
 if wy<y1 then inarea:=false;
 if wy>y2 then inarea:=false;
end;

function  getbestcolor(r,g,b:byte):byte;
var i:integer;bestcolor:byte;errork:word;
    r1,g1,b1:byte;akerror:word;
begin
 bestcolor:=0;errork:=$FFFF;
 for i:=1 to colors do                {Projdeme vsechny barvy}
 begin
  getpalette(i,r1,g1,b1);
  akerror:=        abs(r1-r);         {Vypocitame odchylku slozek cervene}
  akerror:=akerror+abs(g1-g);         {zelene,}
  akerror:=akerror+abs(b1-b);         {a modre, secteme a ulozime do akerror}
  if akerror<errork then              {Jestli je chyba mensi, nez nejmensi,}
  begin                               {tak ji ulozime....}
   errork:=akerror;
   bestcolor:=i;
  end;
 end;
 getbestcolor:=bestcolor;             {...a vratime ji}
end;
function  getbestcolorr(r,g,b:byte;min,max:byte):byte;
var i:integer;bestcolor:byte;errork:word;
    r1,g1,b1:byte;akerror:word;
begin
 bestcolor:=0;errork:=$FFFF;
 for i:=min to max do                {Projdeme vsechny barvy}
 begin
  getpalette(i,r1,g1,b1);
  akerror:=        abs(r1-r);         {Vypocitame odchylku slozek cervene}
  akerror:=akerror+abs(g1-g);         {zelene,}
  akerror:=akerror+abs(b1-b);         {a modre, secteme a ulozime do akerror}
  if akerror<errork then              {Jestli je chyba mensi, nez nejmensi,}
  begin                               {tak ji ulozime....}
   errork:=akerror;
   bestcolor:=i;
  end;
 end;
 getbestcolorr:=bestcolor;             {...a vratime ji}
end;
{---------------------------------------}
procedure PCXfileinfo(s:string;var inf:PCXinfotype);
CONST LINLEN   = 2048;
      PCXHDRSIZE  = 128;
TYPE  CMAPTYP  = ARRAY[0..255,0..2] OF BYTE;
      PALTYP   = ARRAY[0..15,0..2] OF BYTE;
TYPE  HDRTYP = RECORD
        ID,VER,COMPR,BPP  : BYTE;
        X1,Y1,X2,Y2       : WORD;
        RX,RY             : WORD;
        HDRPAL            : PALTYP;
        RES               : BYTE;
        PLANES            : BYTE;
        BYTES             : WORD;
        PAL2              : WORD;
        FILL              : ARRAY[1..58] OF BYTE;
        WID,HIG           : WORD;
        CMAPSIZ           : WORD;
        MONO              : BOOLEAN;
      END;
var   f                   : file;
      CMAP                : CMAPTYP;
      PAL                 : array[0..255,1..3] of byte ABSOLUTE CMAP;
      HDR                 : HDRTYP;
      LINBUF              : ARRAY[0..LINLEN] OF BYTE;

FUNCTION LIESHDR:BOOLEAN;
VAR   FP   : LONGINT;
      I,J  : INTEGER;
      W    : WORD;
BEGIN
  LIESHDR := FALSE;
  BLOCKREAD(F,HDR,PCXHDRSIZE,W);
  IF W <> PCXHDRSIZE THEN EXIT;
  WITH HDR DO BEGIN
    IF ID <> 10 THEN EXIT;
    WID := SUCC(X2 - X1);
    HIG := SUCC(Y2 - Y1);
    CMAPSIZ := 1 SHL (BPP * PLANES);

    IF CMAPSIZ = 2 THEN BEGIN
      CMAP[0,0] := 0;   CMAP[0,1] := 0;   CMAP[0,2] := 0;
      CMAP[1,0] := $FF; CMAP[1,1] := $FF; CMAP[1,2] := $FF;
    END;
    IF CMAPSIZ = 4 THEN BEGIN
      CMAP[0,0] := 0;   CMAP[0,1] := 0;   CMAP[0,2] := 0;
      CMAP[1,0] := 85;  CMAP[1,1] := $FF; CMAP[1,2] := $FF;
      CMAP[2,0] := $FF; CMAP[2,1] := 85;  CMAP[2,2] := $FF;
      CMAP[3,0] := $FF; CMAP[3,1] := $FF; CMAP[3,2] := $FF;
    END;
    IF CMAPSIZ = 16 THEN BEGIN
      MOVE(HDR.HDRPAL,CMAP,48);
    END;
    IF CMAPSIZ = 256 THEN BEGIN
      FP := FILEPOS(F);
      SEEK(F,FILESIZE(F) - 768);
      BLOCKREAD(F,CMAP,768,W);
      SEEK(F,FP);
    END;
    FOR I := 0 TO PRED(CMAPSIZ) DO BEGIN
      FOR J := 0 TO 2 DO CMAP[I][J] := CMAP[I][J] SHR 2;
    END;
    MONO := (BPP = 1) AND (PLANES = 1);
  END;
  LIESHDR := TRUE;
END;
begin
 assign(f,s);reset(f,1);
 LIESHDR;
 close(f);
 inf.ver:=hdr.ver;
 inf.comp:=hdr.compr;
 inf.x:=hdr.wid;
 inf.y:=hdr.hig;
{ inf.palette:=pal;}
end;
procedure loadPCXfile(xx,yy:word;s:string);
CONST LINLEN   = 2048;
      PCXHDRSIZE  = 128;
TYPE  CMAPTYP  = ARRAY[0..255,0..2] OF BYTE;
      PALTYP   = ARRAY[0..15,0..2] OF BYTE;
TYPE  HDRTYP = RECORD
        ID,VER,COMPR,BPP  : BYTE;
        X1,Y1,X2,Y2       : WORD;
        RX,RY             : WORD;
        HDRPAL            : PALTYP;
        RES               : BYTE;
        PLANES            : BYTE;
        BYTES             : WORD;
        PAL2              : WORD;
        FILL              : ARRAY[1..58] OF BYTE;
        WID,HIG           : WORD;
        CMAPSIZ           : WORD;
        MONO              : BOOLEAN;
      END;
var   f                   : file;
      CMAP                : CMAPTYP;
      PAL                 : array[0..255,1..3] of byte ABSOLUTE CMAP;
      HDR                 : HDRTYP;
      LINBUF              : ARRAY[0..LINLEN] OF BYTE;


FUNCTION LIESHDR:BOOLEAN;
VAR   FP   : LONGINT;
      I,J  : INTEGER;
      W    : WORD;
BEGIN
  LIESHDR := FALSE;
  BLOCKREAD(F,HDR,PCXHDRSIZE,W);
  IF W <> PCXHDRSIZE THEN EXIT;
  WITH HDR DO BEGIN
    IF ID <> 10 THEN EXIT;
    WID := SUCC(X2 - X1);
    HIG := SUCC(Y2 - Y1);
    CMAPSIZ := 1 SHL (BPP * PLANES);

    IF CMAPSIZ = 2 THEN BEGIN
      CMAP[0,0] := 0;   CMAP[0,1] := 0;   CMAP[0,2] := 0;
      CMAP[1,0] := $FF; CMAP[1,1] := $FF; CMAP[1,2] := $FF;
    END;
    IF CMAPSIZ = 4 THEN BEGIN
      CMAP[0,0] := 0;   CMAP[0,1] := 0;   CMAP[0,2] := 0;
      CMAP[1,0] := 85;  CMAP[1,1] := $FF; CMAP[1,2] := $FF;
      CMAP[2,0] := $FF; CMAP[2,1] := 85;  CMAP[2,2] := $FF;
      CMAP[3,0] := $FF; CMAP[3,1] := $FF; CMAP[3,2] := $FF;
    END;
    IF CMAPSIZ = 16 THEN BEGIN
      MOVE(HDR.HDRPAL,CMAP,48);
    END;
    IF CMAPSIZ = 256 THEN BEGIN
      FP := FILEPOS(F);
      SEEK(F,FILESIZE(F) - 768);
      BLOCKREAD(F,CMAP,768,W);
      SEEK(F,FP);
    END;
    FOR I := 0 TO PRED(CMAPSIZ) DO BEGIN
      FOR J := 0 TO 2 DO CMAP[I][J] := CMAP[I][J] SHR 2;
    END;
    MONO := (BPP = 1) AND (PLANES = 1);
  END;
  LIESHDR := TRUE;
END;
PROCEDURE ZEIGEBILD;
CONST MASKS   : ARRAY[0..7] OF BYTE = ($80,$40,$20,$10,8,4,2,1);
VAR   X,Y,Z   : WORD;
      B,B2    : BYTE;
      BW,W    : WORD;
      BITMSK  : BYTE;
      BBUF    : ARRAY[0..LINLEN] OF BYTE;

PROCEDURE VGABILD;
VAR  I : integer;
BEGIN
  WITH HDR DO BEGIN
    REPEAT
      IF COMPR = 1 THEN BEGIN
        REPEAT
          BLOCKREAD(F,LINBUF[X],1,W);
          IF LINBUF[X] > $BF THEN BEGIN
            B := LINBUF[X] AND $3F;
            IF B > 0 THEN BEGIN
              BLOCKREAD(F,B2,1,W);
              FILLCHAR(LINBUF[X],B,B2);
              INC(X,B);
            END;
          END ELSE BEGIN
            INC(X);
          END;
        UNTIL X >= BW;
        X := 0;
      END ELSE BEGIN
        BLOCKREAD(F,LINBUF,WID,W);
      END;
      for i:=0 to wid-1 do putpixel(xx+i,yy+y,linbuf[i]);
      INC(Y);
    UNTIL Y >= HIG;
  END;
END;

PROCEDURE MONOBILD;
VAR  I,J  : INTEGER;
BEGIN
  WITH HDR DO BEGIN
    REPEAT
      REPEAT
        BLOCKREAD(F,B,1,W);
        IF B > $BF THEN BEGIN
          B := B AND $3F;
          IF B > 0 THEN BEGIN
            BLOCKREAD(F,B2,1,W);
            FILLCHAR(LINBUF[X],B,B2);
            INC(X,B);
          END;
        END ELSE BEGIN
          LINBUF[X] := B;
          INC(X);
        END;
        IF KEYPRESSED THEN IF READKEY = ^[ THEN exit;
      UNTIL X >= BW;
      X := 0;
      for i:=0 to wid-1 do putpixel(xx+i+y*(WID shr 3) mod 320,yy+i+y*(wid shr 3) div 320,linbuf[i]);
      INC(Y);
    UNTIL Y >= HIG;
  END;
END;

PROCEDURE PLANEBILD;
VAR  I,J,K  : INTEGER;
     RW     : WORD;
BEGIN
  RW := BW * 4;
  WITH HDR DO BEGIN
    REPEAT
      REPEAT
        BLOCKREAD(F,B,1,W);
        IF B > $BF THEN BEGIN
          B := B AND $3F;
          IF B > 0 THEN BEGIN
            BLOCKREAD(F,B2,1,W);
            FILLCHAR(BBUF[X],B,B2);
            INC(X,B);
          END;
        END ELSE BEGIN
          BBUF[X] := B;
          INC(X);
        END;
      UNTIL X >= RW;
      BITMSK := 1;
      FILLCHAR(LINBUF,SIZEOF(LINBUF),0);
      X := 0;
      FOR K := 0 TO 3 DO BEGIN
        FOR I := 0 TO PRED(BW) DO BEGIN
          FOR J := 0 TO 7 DO
            IF (BBUF[X] AND MASKS[J]) <> 0 THEN
              LINBUF[8*I+J] := LINBUF[8*I+J] OR BITMSK;
          INC(X);
        END;
        BITMSK := BITMSK SHL 1;
      END;
      X := 0;
      for i:=1 to wid-1 do putpixel(xx+i,yy+y,linbuf[i]);
      INC(Y);
    UNTIL Y >= HIG;
  END;
END;

PROCEDURE ANDERESBILD;
VAR   PTRN  : ARRAY[0..3] OF BYTE;
      I     : integer;
BEGIN
  WITH HDR DO BEGIN
    REPEAT
      REPEAT
        BLOCKREAD(F,B,1,W);
        IF B > $BF THEN BEGIN
          B := B AND $3F;
          IF B > 0 THEN BEGIN
            BLOCKREAD(F,B2,1,W);
            PTRN[0] := B2 SHR 6;
            PTRN[1] := (B2 SHR 4) AND 3;
            PTRN[2] := (B2 SHR 2) AND 3;
            PTRN[3] := B2 AND 3;
            FOR I := 1 TO B DO BEGIN
              MOVE(PTRN,LINBUF[X],4);
              INC(X,4);
            END;
          END;
        END ELSE BEGIN
          LINBUF[X] := B SHR 6;
          INC(X);
          LINBUF[X] := (B SHR 4) AND 3;
          INC(X);
          LINBUF[X] := (B SHR 2) AND 3;
          INC(X);
          LINBUF[X] := B AND 3;
          INC(X);
        END;
        IF KEYPRESSED THEN IF READKEY = ^[ THEN exit;
      UNTIL X >= WID;
      X := 0;
      for i:=1 to wid do putpixel(xx+i,yy+y,linbuf[i]);
      INC(Y);
    UNTIL Y >= HIG;
  END;
END;

BEGIN
  X := 0;
  Y := 0;
  WITH HDR DO BEGIN
    BW := BYTES;
    IF MONO THEN MONOBILD
    ELSE BEGIN
      IF PLANES > 1 THEN PLANEBILD
      ELSE BEGIN
        IF BPP = 8 THEN VGABILD
                   ELSE ANDERESBILD;
      END;
    END;
  END;
END;

begin           {Begin of drawPCXfile}
 assign(f,s);reset(f,1);
 LIESHDR;
 ZEIGEBILD;
 close(f);
end;              {End of drawPCXfile}

{---------------------------------------}

function charx(ch:char;poc:integer):string;
var  i:integer;s:string;
begin
 s:='';for i:=1 to poc do s:=s+ch;charx:=s;
end;

begin
 screen:=ptr($A000,0000);
 TextOrientation:=horizontal;
 mstart:=true;
 ready:=true;
 mco:=false;
 curzm:=k_sipka;
 initstd;
end.